﻿import os
import time
from queue import Queue
from tkinter import Tk, Menu, Button, filedialog, messagebox, Toplevel, Label, Entry, Frame, Canvas, StringVar
from threading import Thread
from aip import AipOcr
# @卜平凡


class Window(Tk):
    def __init__(self):
        super().__init__()
        # 结果缓存
        self.result = []
        # 答题卡路径
        self.dirPath = ''
        self.fileList = None
        # 题目数量弹窗
        self.tc_subjectNum = None
        # 题目数量文本框缓存
        self.subjectNameText = None
        # 题目数量
        self.subjectNum = ''
        # 设置答案弹窗
        self.tc_setKey = None
        # 答案/分值
        self.key = {}
        # 答案/分值文本框缓存
        self.textList = []
        self.uiInit()
        # 进度条弹窗
        self.tc_read = None

    def uiInit(self):
        # 标题栏
        self.title('智能阅卷V1.6')
        # 图标
        # self.iconbitmap('./fac.ico')
        # 屏幕宽度
        sw = self.winfo_screenwidth()
        sh = self.winfo_screenheight()
        # 窗口大小
        ww = 280
        wh = 200
        # 窗口宽高为100
        x = (sw - ww) / 2
        y = (sh - wh - 200) / 2
        self.geometry("%dx%d+%d+%d" % (ww, wh, x, y))
        # 禁止缩放
        self.resizable(0, 0)
        # 菜单
        self.menu()
        # 选择文件夹按钮
        self.bt_getDirPath()
        # 设置答案/题目按钮
        self.bt_setKey()
        # 阅卷按钮
        self.bt_read()
        # 窗口展示
        self.mainloop()

    def menu(self):
        menubar = Menu(self)
        # 　定义一个空的菜单单元
        about = Menu(menubar, tearoff=0)
        menubar.add_cascade(label='关于', menu=about)
        about.add_command(label='说明', command=self.shuoMing)
        about.add_command(label='作者', command=self.zuoZhe)
        about.add_command(label='版权', command=self.banQuan)
        about.add_command(label='历史版本', command=self.liShi)
        self.config(menu=menubar)

    @staticmethod
    def shuoMing():
        messagebox.showinfo('说明', '1、选择答题卡扫描照片的放置文件夹\n'
                                  '2、设置答案/题目\n'
                                  '3、阅卷根据提示获取表格文件\n'
                                  '4、答题卡填写要求：\n'
                                  '   a、答题卡须书写规范\n'
                                  '   b、考号与答案紧挨着写提高识别精度\n'
                                  '   c、铅笔答题方便修改、禁止书面涂改')

    @staticmethod
    def zuoZhe():
        messagebox.showinfo('作者', '豪迈职校IT小组，卜平凡')

    @staticmethod
    def banQuan():
        messagebox.showinfo('版权', '软件遵循GPL协议\n'
                                  '软件解释权归潍坊市豪迈科技职业中等专业学校所有')

    @staticmethod
    def liShi():
        messagebox.showinfo('历史', 'V1.0 发布\n'
                                  'V1.1 优化答题卡 修复识别错误导致软件无法退出BUG\n'
                                  'V1.2 增加题目数量输入数字的验证\n'
                                  'V1.3 增加步骤验证\n'
                                  'V1.4 增加保存填写后的题目答案与分值\n'
                                  'V1.5 编译为windows平台下的单个应用\n'
                                  'V1.6修复因弹窗关闭导致软件无法退出BUG')

    def bt_getDirPath(self):
        # 用于获取文件夹地址的按钮
        bt = Button(self,
                    text='选择文件夹',
                    command=self.getDirPath)
        bt.pack(pady=10)

    def getDirPath(self):
        self.dirPath = filedialog.askdirectory()
        if self.dirPath != '':
            # 获取所有答题卡文件名
            self.fileList = os.listdir(self.dirPath)
            messagebox.showinfo('', '选择成功')
        else:
            messagebox.showinfo('', '选择失败')

    def bt_setKey(self):
        # 用于获取文件夹地址的按钮
        bt = Button(self,
                    text='设置答案/分值',
                    command=self.tc_getSubjectNum)
        bt.pack(pady=10)

    def tc_getSubjectNum(self):
        # 用于题目数量获取窗口
        if self.dirPath != '':
            self.withdraw()
            self.tc_subjectNum = Toplevel(self)
            # 绑定关闭响应事件
            self.tc_subjectNum.protocol("WM_DELETE_WINDOW", self.tc_subjectNumClose)
            self.tc_subjectNum.title('题目数量')
            # self.tc_subjectNum.iconbitmap('./fac.ico')
            sw = self.winfo_screenwidth()
            sh = self.winfo_screenheight()
            # 窗口大小
            ww = 260
            wh = 70
            # 窗口宽高为100
            x = (sw - ww) / 2
            y = (sh - wh - 200) / 2
            self.tc_subjectNum.geometry("%dx%d+%d+%d" % (ww, wh, x, y))
            self.tc_subjectNum.resizable(0, 0)
            self.subjectNameText = Entry(self.tc_subjectNum, width=6)
            self.subjectNameText.pack()
            Button(self.tc_subjectNum, text='确定', command=self.tc_sheet).pack(pady=10)
        else:
            messagebox.showinfo('', '请选择答题卡文件夹再进行操作')

    def tc_subjectNumClose(self):
        # 显示主窗口
        self.deiconify()
        # 销毁sheet窗口
        self.tc_subjectNum.destroy()

    def tc_sheet(self):
        # 获取题目文本框数据
        try:
            self.subjectNum = float(self.subjectNameText.get())
            # 销毁题目数量窗口
            self.tc_subjectNum.destroy()
            self.tc_setKey = Toplevel(self)
            # 绑定关闭响应事件
            self.tc_setKey.protocol("WM_DELETE_WINDOW", self.tc_setKeyClose)
            self.tc_setKey.title('设置答案/分值')
            # self.tc_setKey.iconbitmap('./fac.ico')
            sw = self.winfo_screenwidth()
            sh = self.winfo_screenheight()
            # 窗口大小
            ww = int(self.subjectNum) * 28 + 280
            wh = 110
            # 窗口宽高为100
            x = (sw - ww) / 2
            y = (sh - wh - 200) / 2
            self.tc_setKey.geometry("%dx%d+%d+%d" % (ww, wh, x, y))
            self.tc_setKey.resizable(1, 0)
            a = Frame(self.tc_setKey)
            Label(a, text='题号').grid(row=1, column=0)
            Label(a, text='答案').grid(row=2, column=0)
            Label(a, text='分值').grid(row=3, column=0)
            for temp in range(int(self.subjectNum)):
                Label(a, text=temp + 1).grid(row=1, column=temp + 1)
                k = Entry(a, width=4)
                k.grid(row=2, column=temp + 1)
                v = Entry(a, width=4)
                v.grid(row=3, column=temp + 1)
                # 缓存文本框对象
                self.textList.append([k, v])
            Button(a, text='确定', command=self.setKey).grid(row=4, column=int(int(self.subjectNum) / 2), pady=10)
            a.pack()
        except ValueError:
            messagebox.showinfo('', '请正确输入题目数量')

    def tc_setKeyClose(self):
        # 显示主窗口
        self.deiconify()
        # 销毁sheet窗口
        self.tc_setKey.destroy()

    def setKey(self):
        # 用于整合设置答案/分值窗口数据
        try:
            i = 1
            for temp in self.textList:
                self.key[i] = [temp[0].get(), float(temp[1].get())]
                i = i + 1
            # 保留题目答案/分值信息
            file = open('key.csv', 'w+')
            file.write('%s,%s,%s\n' % ('题目', '答案', '分值'))
            for k, v in self.key.items():
                file.write('%s,%s,%s\n' % (str(k), str(v[0]), str(v[1])))
            file.close()
            # 销毁设置答案/分值窗口
            self.tc_setKey.destroy()
            messagebox.showinfo('', '答案/分值设置成功')
            # 显示主窗口
            self.deiconify()
        except ValueError:
            self.tc_setKey.withdraw()
            messagebox.showinfo('', '请将答案/分值填写完整与正确')
            self.tc_setKey.deiconify()

    def bt_read(self):
        # 阅卷按钮
        Button(self, text='阅卷', command=self.tc_read).pack(pady=10)

    def tc_read(self):
        # 阅卷窗口
        # 主窗口隐藏
        self.withdraw()
        self.tc_read = Toplevel(self)
        self.tc_read.protocol("WM_DELETE_WINDOW", self.tc_readClose)
        self.tc_read.title('阅卷')
        # self.tc_read.iconbitmap('./fac.ico')
        # 屏幕宽度
        sw = self.winfo_screenwidth()
        sh = self.winfo_screenheight()
        # 窗口大小
        ww = 280
        wh = 150
        # 窗口宽高为100
        x = (sw - ww) / 2
        y = (sh - wh - 200) / 2
        self.tc_read.geometry("%dx%d+%d+%d" % (ww, wh, x, y))
        self.tc_read.resizable(0, 0)
        canvas = Canvas(self.tc_read, width=195, height=25, bg='dimgrey')
        canvas.pack(pady=20)
        x = StringVar()
        # 进度条以及完成程度
        fill_rec = canvas.create_rectangle(0, 0, 0, 30, outline="", fill="green")
        Label(self.tc_read, textvariable=x).pack(pady=1)
        # 队列
        q = Queue()
        # 阅卷处理线程
        handle = Thread(target=self.read, args=(q,))
        handle.start()
        # 进度条变化
        readNum = 100 / len(self.fileList)
        while 1:
            var = q.get() + 1
            x.set(str(round(readNum * var, 0)) + '%')
            canvas.coords(fill_rec, (0, 0, readNum * var * 2, 30))
            self.tc_read.update()
            if var == len(self.fileList):
                break
        self.tc_read.destroy()
        self.resultToCsv()
        messagebox.showinfo('', '阅卷完成!\n请于当前目录查收成绩单【result.csv】')
        self.destroy()
        exit()

    @staticmethod
    def tc_readClose():
        messagebox.showinfo('', '阅卷中！')

    def getData(self, fileName):

        # 用于识别答题卡整合数据
        APP_ID = '17496355'
        API_KEY = 'xe94CBXG6IgGzee2hX2CacsI'
        SECRET_KEY = '0beiI5lGdkBWeHZPs56cPl5dOYS6LV0c'
        api_client = AipOcr(APP_ID, API_KEY, SECRET_KEY)
        # 限速
        time.sleep(0.2)
        # 获取识别字符串数据
        file = open(self.dirPath + '/' + fileName, 'rb')
        img = file.read()
        file.close()
        # 识别数据缓存
        strList = []
        varList = []
        try:
            strData = api_client.basicAccurate(img)['words_result']
            for temp in strData:
                strList.append(temp['words'])
        except KeyError:
            messagebox.showinfo('', '数据错误')
            self.tc_read().destroy()
            self.destroy()
        # 整合数据
        try:
            for temp in strList[2:]:
                for var in temp:
                    if var.isalpha():
                        varList.append(var)
            # [考号, 答案]
            return [strList[1][2:], varList]
        except IndexError:
            messagebox.showinfo('', '数据错误')
            self.tc_read().destroy()
            self.destroy()

    def resultToCsv(self):
        # 用于生成成绩报表
        file = open('result.csv', 'w+')
        # 设置标题
        file.write('学号')
        for temp in range(1, int(self.subjectNum) + 1):
            file.write(',%d' % temp)
        file.write(',%s' % '总分')
        file.write('\n')
        # 写入结果
        for temp in self.result:
            # 记录成绩总数
            h = 0
            # 写入学号
            file.write(temp[0])
            # 写入成绩
            for var in temp[1]:
                h = h + float(var)
                file.write(',%s' % str(var))
            file.write(',%d' % h)
            file.write('\n')
        file.close()

    def read(self, q):
        # 线程处理阅卷
        j = 0
        q.put(j)
        for fileName in self.fileList:
            data = self.getData(fileName)
            kid = data[0]
            keyList = data[1]
            # 得分缓存
            resultVar = []
            i = 1
            for temp in keyList:
                if temp == self.key[i][0]:
                    resultVar.append(self.key[i][1])
                else:
                    resultVar.append(0)
                i = i + 1
            self.result.append([kid, resultVar])
            # 发送数据到主线程
            q.put(j)
            print(data)
            print(kid, resultVar)
            print('#' * 20)
            print()
            j = j + 1


if __name__ == '__main__':
    master = Window()